# Monte Carlo Tree Search based Space Transfer for Black Box Optimization

This repository contains the Python code for MCTS-Transfer , an search space transfer algorithm for  expensive Black-Box Optimization.

MCTS-Transfer employed MCTS to pre-learn search space partitions on offline datasets and adjust it during optimization.

The code is implemented based on [LA-MCTS](https://github.com/facebookresearch/LaMCTS/tree/main).

## Requirements

Ubuntu == 20.04

Python == 3.8.0

```
pip install -r requirements.txt
```

## Usage

```
# test on Sphere2D
bash run_sphere.sh

# test on BBOB
bash run_bbob.sh

# test on real-world problem
bash run_real.sh
```

